package de.hendriklipka.databus;

import java.util.Vector;

import org.w3c.dom.*;
import com.sun.xml.parser.Resolver;
import com.sun.xml.tree.XmlDocument;
import org.xml.sax.InputSource;

import org.log4j.Category;

class ComponentDescriptor
{
    static Category CAT = Category.getInstance(ComponentDescriptor.class.getName());

    public String _componentName=null;
    public String _componentClass=null;
    public String _componentDescription=null;
    public String[] _listenTo=null;
    public String[] _produces=null;
    public boolean _isGenericProducer=false;

    public ComponentDescriptor(Node configNode)
    {
        try
        {
            Vector input=new Vector();
            Vector output=new Vector();

            NodeList nl=configNode.getChildNodes();
            for (int i=0;i<nl.getLength();i++)
            {
                Node node=nl.item(i);
                if (node.getNodeType()==node.ELEMENT_NODE)
                {
                    if(node.getNodeName().equals("name"))
                    {
                        _componentName=DataBus.getTextData(node);
                    }
                    else if(node.getNodeName().equals("class"))
                    {
                        _componentClass=DataBus.getTextData(node);
                    }
                    else if(node.getNodeName().equals("description"))
                    {
                        _componentDescription =DataBus.getTextData(node);
                    }
                    else if(node.getNodeName().equals("input"))
                    {
                        String s=DataBus.getTextData(node);
                        input.addElement(s);
                    }
                    else if(node.getNodeName().equals("output"))
                    {
                        String s=DataBus.getTextData(node);
                        output.addElement(s);
                    }
                    else if(node.getNodeName().equals("configuration"))
                    {
                        // ignore - not needed here
                    }
                }
            }
            if (input.size()>0)
            {
                _listenTo=new String[input.size()];
                for (int i=0;i<input.size();i++)
                {
                    _listenTo[i]=(String)input.elementAt(i);
                }
            }
            if (output.size()>0)
            {
                _produces=new String[output.size()];
                for (int i=0;i<output.size();i++)
                {
                    _produces[i]=(String)output.elementAt(i);
                }
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
            CAT.error(ex);
        }
    }
}
