/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.event;

import org.log4j.Category;

/**
    this event is send if a component wants to send a command request to a running server
*/
public class GameControlEvent
{
    static Category CAT = Category.getInstance(GameControlEvent.class.getName());

  public final static String NAME="GameControl";
  public int _type=USER_DEFINED;
  public String _param1=null;
  public String _param2=null;

  public static final int USER_DEFINED=0; // String
  public static final int SHUTDOWN=2 ;
  public static final int SERVER_STATUS=4 ; // ServerInfo
  public static final int PLAYER_LIST=6 ; // PlayerInfo[]
  public static final int PLAYER_INFO_FOR_NAME=8 ; // PlayerInfo
  public static final int PLAYER_INFO_FOR_ID=9 ; // PlayerInfo
  public static final int GET_LOCAL_VARS=10 ; // Properties
  public static final int SET_LOCAL_VAR=14 ; // String,String
  public static final int GET_SERVER_VARS=16 ; // Properties
  public static final int SET_SERVER_VAR=20 ; //String,String
  public static final int MAP_CHANGE=22 ; // String
  public static final int KICK_USER=24 ; // ID
  public static final int MESSAGE=26 ; // String
  public static final int MESSAGE_TO_USER=28 ; // ID,String
}
