/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.event;

import java.util.*;

import org.log4j.Category;

import de.hendriklipka.gcp.module.control.*;

/**
  A GameEvent represents an event occured during game play in a
  standardized form.
*/
public class GameEvent extends java.lang.Object
{
    static Category CAT = Category.getInstance(GameEvent.class.getName());

    public final static String NAME="Game";
  
    /**
        time at which the event occured
    */
    public Date _eventDate=null;
      
    /**
        Type of this event
        the value could be choosed free, but some type are predefined:
	        "addplayer"
	        "removeplayer"
	        "renameplayer"
	        "startserver"
	        "endserver"
	        "startmap"
	        "endmap"
    */
    public String _type=null;
      
    public String _id=null;
      
    /**
        These properties contain the parsed data for this event
        parsing is done in LineFilter and is free configurable
    */
    public Properties _data=new Properties();
      
    /**
        The original line (message) for this event
    */
    public String _line=null;
}
