/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.event;

import org.log4j.Category;

import java.util.*;
/**
  An InputEvent represents a message generated by the running game.
  InputEvents are created by InputFilters
  @see hli.Analyzer.InputFilterBase
*/
public class InputEvent extends java.lang.Object
{
    static Category CAT = Category.getInstance(InputEvent.class.getName());

    public static final String NAME="Input";

    /**
        The original text of the message
    */
    public String _originalLine=null;

    /**
        The text of the message, but eventually processed by a MessageTransformer
    */
    public String _line=null;

    /**
        The text of the message, but enriched with color information
    */
    public String _coloredLine=null;
    
    /**
        the time when this message was generated
    */
    public Date _eventDate=null;
}
