package de.hendriklipka.gcp.module.admin.handler;

import org.log4j.Category;

import org.w3c.dom.*;

import de.hendriklipka.databus.*;
import de.hendriklipka.util.*;

import de.hendriklipka.gcp.exception.*;
import de.hendriklipka.gcp.event.*;

/**
    CommandHandler for administrative purposes
    can shutdown a server and send rcon commands
    @see de.hendriklipka.gcp.module.input.network.NetworkControlHandler
*/
public class AdminCommandHandler extends de.hendriklipka.gcp.module.admin.handler.CommandHandler
{
    static Category CAT = Category.getInstance(AdminCommandHandler.class.getName());

    public void init(DataBus bus, Node node)
    {
        super.init(bus,node);
    }

    public String[] getHandlerCommands()
    {
        String[] st={"shutdown","startup","killserver","rcon"};
        return st;
    }

    public CommandResponse handleCommand(String s)
    {
        if (s.equals("shutdown"))
        {
            ProcessControlEvent pce=new ProcessControlEvent();
            pce._type=ProcessControlEvent.SHUTDOWN;
            _bus.sendResponseData(pce,ProcessControlEvent.NAME,this);
            return new CommandResponse(null);
        }
        else if (s.equals("startup"))
        {
            ProcessControlEvent pce=new ProcessControlEvent();
            pce._type=ProcessControlEvent.STARTUP;
            _bus.sendResponseData(pce,ProcessControlEvent.NAME,this);
            return new CommandResponse(null);
        }
        else if (s.equals("killserver"))
        {
            ProcessControlEvent pce=new ProcessControlEvent();
            pce._type=ProcessControlEvent.KILL_PROCESS;
            _bus.sendResponseData(pce,ProcessControlEvent.NAME,this);
            return new CommandResponse(null);
        }
        else if (s.equals("rcon"))
        {
            s=s.substring(4).trim();
            GameControlEvent gce=new GameControlEvent();
            gce._type=GameControlEvent.USER_DEFINED;
            gce._param1=s;
            Object o=_bus.sendResponseData(gce,GameControlEvent.NAME,this);
            String answer="";
            try
            {
                answer=((GameControlResponse)o)._response;
            }
            catch (Exception ex)
            {
                CAT.error(ex);
            }
            if (null==answer)
                answer="";
            return new CommandResponse(answer);
        }
        return new CommandResponse();
    }
}
