package de.hendriklipka.gcp.module.admin.handler;

import org.log4j.Category;

import org.w3c.dom.*;

import de.hendriklipka.databus.*;
import de.hendriklipka.util.*;

import de.hendriklipka.gcp.exception.*;
import de.hendriklipka.gcp.event.*;

/**
    simple command handler
    @see de.hendriklipka.gcp.module.input.network.NetworkControlHandler
*/
public class StdCommandHandler extends de.hendriklipka.gcp.module.admin.handler.CommandHandler
{
    static Category CAT = Category.getInstance(CommandHandler.class.getName());

    public void init(DataBus bus, Node node)
    {
        super.init(bus,node);
    }
            
    public String[] getHandlerCommands()
    {
        String[] st={"stat"};
        return st;
    }

    public CommandResponse handleCommand(String s)
    { 
        CAT.info("handling: "+s);
        if (s.equals("stat"))
        {
            CAT.info("doing status");
            GameControlEvent gce=new GameControlEvent();
            gce._type=GameControlEvent.SERVER_STATUS;
            Object o=_bus.sendResponseData(gce,GameControlEvent.NAME,this);
            String answer="";
            try
            {
                answer=((GameControlResponse)o)._serverStatus.toString();
            }
            catch (Exception ex) 
            {
                CAT.error(ex);
            }
            if (null==answer) 
                answer="";
            return new CommandResponse(answer); 
        }
        return new CommandResponse();
    }
}
