/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.control;

import java.util.Properties;
import java.util.Enumeration;

import org.log4j.Category;

/**
    this class encapsulates information about a single player
*/
public class PlayerInfo
{
    static Category CAT = Category.getInstance(PlayerInfo.class.getName());

  protected Properties _data=new Properties();
  protected String _id=null;
  protected String _name=null;
  
  public void setData(Properties props)
  {
    if (null==_data)
      _data=props;
    else
    {
      Enumeration e=props.propertyNames();
      while (e.hasMoreElements())
      {
        String k=(String)e.nextElement();
        _data.put(k,props.getProperty(k));
      }
    }
  }
  
  public void set(String name, String value)
  {
    _data.put(name,value);
  }
  
  public Properties getData()
  {
    return _data;
  }
  
  public void copy(PlayerInfo pi)
  {
    if(!(pi._id).equals(_id))
    {
      return;
    }
    if (null==_data)
      _data=pi._data;
    else
    {
      Enumeration e=pi._data.propertyNames();
      while (e.hasMoreElements())
      {
        String k=(String)e.nextElement();
        _data.put(k,pi._data.getProperty(k));
      }
    }
  }
  
  public void setID(String s)
  {
    _id=s;
    set("id",s);
  }
  
  public String getID()
  {
    return _id;
  }
  
  public void setName(String s)
  {
    _name=s;
    set("name",s);
  }
  
  public String getName()
  {
    return _name;
  }
}
