/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.control.quake;

import java.net.*;
import java.io.*;
import java.util.*;

import org.w3c.dom.*;
import org.log4j.Category;

import de.hendriklipka.databus.*;

import de.hendriklipka.util.*;

import de.hendriklipka.gcp.exception.*;
import de.hendriklipka.gcp.event.*;
import de.hendriklipka.gcp.module.control.*;

/**
  sends requests to a running Quake2-Server via UDP.
*/
public class Q2ProtocolHandler extends QWProtocolHandler
{
    static Category CAT = Category.getInstance(Q2ProtocolHandler.class.getName());
//ToDo ??
/*      
    public void sendShutdownRequest() throws HandleException // SHUTDOWN
    {
        String s=sendARequest("rcon "+_password+" quit");
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    }

    public ServerInfo sendServerStatusRequest() throws HandleException
    {
        String s=sendARequest("status");
        ServerInfo si=parseServerInfo1(s);
        s=sendARequest("rcon "+_password+" status");
        ServerInfo si2=parseServerInfo2(s);
        s=sendARequest("rcon "+_password+" localinfo");
        ServerInfo si3=parseServerInfo3(s);
        si.copy(si2);
        si.copy(si3);
        return si;
    }
      
    public PlayerInfo[] sendPlayerListRequest() throws HandleException
    {
        String s=sendARequest("status");
        ServerInfo si=parseServerInfo1(s);
        return si._players;
    }
      
    public PlayerInfo sendPlayerInfoRequest(String name) throws HandleException
    {
        String s=sendARequest("status");
        ServerInfo si=parseServerInfo1(s);
        s=sendARequest("rcon "+_password+" status");
        ServerInfo si2=parseServerInfo2(s);
        si.copy(si2);
        if (null!=si._players)
        {
            for (int i=0;i<si._players.length;i++)
            {
                PlayerInfo pi=si._players[i];
                if (name.equals(pi.getName()))
                {
                    s=sendARequest("rcon "+_password+" user "+pi.getID());
                    PlayerInfo pi2=parsePlayerInfo(s);
                    pi.copy(pi2);
                    return pi;
                }
            }
        }
        throw new HandleException("player not found");
    } 
      
    public PlayerInfo sendPlayerInfoRequest(long id) throws HandleException
    {
        String sid=Long.toString(id);
        String s=sendARequest("status");
        ServerInfo si=parseServerInfo1(s);
        s=sendARequest("rcon "+_password+" status");
        ServerInfo si2=parseServerInfo2(s);
        si.copy(si2);
        if (null!=si._players)
        {
            for (int i=0;i<si._players.length;i++)
            {
                PlayerInfo pi=si._players[i];
                if (sid.equals(pi.getID()))
                {
                    s=sendARequest("rcon "+_password+" user "+pi.getID());
                    PlayerInfo pi2=parsePlayerInfo(s);
                    pi.copy(pi2);
                    return pi;
                }
            }
        }
        throw new HandleException("player not found");
    } 
      
    public void sendSetLocalVarRequest(String name, String value) throws HandleException
    {
        String s=sendARequest("rcon "+_password+" set "+name+" "+value);
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    } 
      
    public Properties sendGetLocalVarsRequest() throws HandleException
    {
        String s=sendARequest("rcon "+_password+" localinfo");
        ServerInfo si3=parseServerInfo3(s);
        return si3.getData();
    }
      
    public void sendSetServerVarRequest(String name, String value) throws HandleException
    {
        String s=sendARequest("rcon "+_password+" set "+name+" "+value);
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    } 
      
    public Properties sendGetServerVarsRequest() throws HandleException
    {
        String s=sendARequest("rcon "+_password+" serverinfo");
        ServerInfo si2=parseServerInfo2(s);
        return si2.getData();
    } 
      
    public void sendMapChangeRequest(String name) throws HandleException
    {
        String s=sendARequest("rcon "+_password+" map "+name);
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    } 
      
    public void sendKickUserRequest(long id) throws HandleException
    {
        String s=sendARequest("rcon "+_password+" kick "+id);
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    }
      
    public void sendMessageRequest(String msg) throws HandleException
    {
        String s=sendARequest("rcon "+_password+" say "+msg);
        if (0!=s.length())
        {
            throw new HandleException(s);
        }
    }
      
    public void sendMessageToUserRequest(long id, String msg) throws HandleException
    {
        throw new HandleException("operation not supported");
    }

    public String sendRequest(String command) throws HandleException
    {
        return sendARequest("rcon "+_password+" "+command);
    }
*/
/*      
    public String sendARequest(String command) throws HandleException
    {
        String result=null;
        try
        {
            byte[] p=sendPacket(command,_ip,_port);
            int len=p.length;
            StringBuffer sb=new StringBuffer();
            for (int i=0;i<len;i++)
            sb.append((char)p[i]);
            result=resultToString(sb.toString());
            if (result.equals("Bad rcon_password."))
            {
                throw new HandleException("Bad rcon_password");
            }
        }
        catch (HandleException ex) 
        {
            throw ex;
        }
        catch (Exception ex) 
        {
            throw new HandleException(ex);
        }
        if (null==result)
        {
            throw new HandleException("no result received within timeout");
        }
        return result;
    }
*/
    // parse "status"
    /*
    maxclients\8\spawn\0\watervis\0\*version\2.30\*gamedir\fortress\hostname\TF on w
    anderer\maxspectators\5\maxplayer\10\maxplayers\10\s\off\g\on\deathmatch\3\teamp
    lay\31?TF2.5\timelimit\30\fraglimit\100\samelevel\2\*progs\59258\map\2fort5\n\2
    3 0 12 51 "12345678901234567890" "tf_medic" 13 13  
    */
    public ServerInfo parseServerInfo1(String s)
    {
        CAT.info("parseServerInfo1 for "+s);
        int pos=s.indexOf('\n');
        String pl=null;
        if (-1!=pos)
        {
            pl=s.substring(pos);
            s=s.substring(0,pos);
        }
        Properties p=new Properties();
        StringTokenizer st=new StringTokenizer(s,"\\");
        while (st.hasMoreElements())
        {
            String name=((String)st.nextElement()).trim();
            String value=((String)st.nextElement()).trim();
            p.put("server_"+name,value);
        }
        ServerInfo si=new ServerInfo();
        si.setData(p);
            
        // parse existing gplayers
        if (null!=pl)
        {
            Vector v=new Vector();
            st=new StringTokenizer(pl,"\n");
            while (st.hasMoreElements())
            {
                String line=(String)st.nextElement();
                line=line.trim();
                if (0==line.length())
                    continue;
                pos=line.indexOf(' ');
                String id=line.substring(0,pos);
                line=line.substring(pos+1);

                pos=line.indexOf(' ');
                String frags=line.substring(0,pos);
                line=line.substring(pos+1);

                pos=line.indexOf(' ');
                String time=line.substring(0,pos);
                line=line.substring(pos+1);

                pos=line.indexOf(' ');
                String ping=line.substring(0,pos);
                line=line.substring(pos+1);

                if (line.startsWith("\""))
                    line=line.substring(1);
                pos=line.indexOf('"');
                String name=new String(line.substring(0,pos));
                line=line.substring(pos+2);
                        
                if (line.startsWith("\""))
                    line=line.substring(1);
                pos=line.indexOf('"');
                String skin=line.substring(0,pos);
                line=line.substring(pos+2);
                        
                pos=line.indexOf(' ');
                String shirtColor=line.substring(0,pos);
                line=line.substring(pos+1);
                        
                String pantsColor=line;
                        
                PlayerInfo pi=new PlayerInfo();
                pi.setID(id);
                pi.setName(name);
                pi.set("skin",skin);
                pi.set("topcolor",shirtColor);
                pi.set("bottomcolor",pantsColor);
                pi.set("frags",frags);
                pi.set("ping",ping);
                pi.set("time",time);
                v.addElement(pi);
            }
            if (0!=v.size())
            {
                si._players=new PlayerInfo[v.size()];
                for (int i=0;i<v.size();i++)
                {
                    si._players[i]=(PlayerInfo)v.elementAt(i);
                }
            }
        }
        return si;
    }

    // parse "rcon status" 
    /*
    net address      : 192.168.0.4:27500
    cpu utilization  :   0%
    avg response time: 0 ms
    packets/frame    :  0.21 (10)
    name               userid frags
    address          rate ping drop
    ---------------- ---- ---- -----
    1234567890123456       1    -3
    127.0.0.1         54   50  0.00
    */
    public ServerInfo parseServerInfo2(String s)
    {
        CAT.info("parseServerInfo2 for "+s);
        ServerInfo si=new ServerInfo();
        Vector v=new Vector();
        StringTokenizer st=new StringTokenizer(s,"\n");
        String d=(String)st.nextElement(); // net address
        String address=d.substring(19);
        d=(String)st.nextElement(); // cpu util
        String cpu=d.substring(19,d.indexOf('%')).trim();
        si.set("server_cpu",cpu);
        d=(String)st.nextElement(); // response time
        String response=d.substring(19,d.indexOf("ms")).trim();
        si.set("server_time",response);
        d=(String)st.nextElement(); // packets/frame
        String packets=d.substring(19,d.indexOf("(")).trim();
        st.nextElement(); // name...
        st.nextElement(); // address...
        st.nextElement(); // ---...
            
        while (st.hasMoreElements())
        {
            String first=null;
            String f=null;
            String next=null;
            String n=null;
            try
            {
                boolean isSpec=false;
                boolean connecting=false;
                f=(String)st.nextElement();
                n=(String)st.nextElement();
                first=f;
                next=n;
                        
                String name=f.substring(0,18).trim();
                f=f.substring(18);
                while (f.startsWith(" "))
                f=f.substring(1);
                        
                int pos=f.indexOf(' ');
                String id=f.substring(0,pos);
                f=f.substring(pos);
                        
                while (f.startsWith(" "))
                f=f.substring(1);
                pos=f.indexOf(' ');
                String data="";
                if (-1!=pos)
                {
                    data=f.substring(0,pos);
                    f=f.substring(pos).trim();
                    if (f.equals("(s)"))
                    isSpec=true;
                }
                else
                {
                    data=f;
                }
                String frags=data;
                        
                String ip=n.substring(0,18).trim();
                n=n.substring(18);
                while (n.startsWith(" "))
                n=n.substring(1);
                        
                String rate="0";
                String drop="0";
                String ping="0";
                if (0<=n.indexOf("CONNECTING"))
                {
                    connecting=true;
                }
                else
                {
                    connecting=false;
                    pos=n.indexOf(' ');
                    rate=n.substring(0,pos);
                    n=n.substring(pos);
                              
                    while (n.startsWith(" "))
                    n=n.substring(1);
                    pos=n.indexOf(' ');
                    ping=n.substring(0,pos);
                    n=n.substring(pos);

                    while (n.startsWith(" "))
                    n=n.substring(1);
                    drop=n;
                }
                        
                PlayerInfo pi=new PlayerInfo();
                pi.setName(name);
                pi.setID(id);
                pi.set("frags",frags);
                pi.set("address",ip);
                pi.set("currentrate",rate);
                pi.set("ping",ping);
                pi.set("drop",drop);
                pi.set("*spectator",isSpec?"1":"0");
                pi.set("connecting",connecting?"1":"0");
                v.addElement(pi);
            }
            catch (Exception ex) 
            {
            }
        }
        if (0!=v.size())
        {
            si._players=new PlayerInfo[v.size()];
            for (int i=0;i<v.size();i++)
            {
                si._players[i]=(PlayerInfo)v.elementAt(i);
            }
        }
        return si;
    }
      
    // parse "rcon localinfo"
    public ServerInfo parseServerInfo3(String s)
    {
        CAT.info("parseServerInfo3 for "+s);
        Properties p=new Properties();
        StringTokenizer st=new StringTokenizer(s,"\n");
        String msg=(String)st.nextElement();
        if (!msg.startsWith("Local info settings:"))
            return null;
        while (st.hasMoreElements())
        {
            String line=(String)st.nextElement();
            if (line.length()<=20)
                continue;
            String name=line.substring(0,20).trim();
            String value=line.substring(20).trim();
            p.put("server_"+name,value);
        }
        ServerInfo si=new ServerInfo();
        si.setData(p);
        return si;
    }

    // parse "user #"
    public PlayerInfo parsePlayerInfo(String s)
    {
        CAT.info("parsePlayerInfo for "+s);
        Properties p=new Properties();
        StringTokenizer st=new StringTokenizer(s,"\n");
        while (st.hasMoreElements())
        {
            String line=(String)st.nextElement();
            if (line.length()<=20)
                continue;
            String name=line.substring(0,20).trim();
            String value=line.substring(20).trim();
            p.put(name,value);
        }
        PlayerInfo pi=new PlayerInfo();
        pi.setData(p);
        return pi;
    }
}
