/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.kicker.autokicker.eval;

import java.util.Properties;

import org.w3c.dom.*;
import org.log4j.Category;


public class Field
{
    static Category CAT = Category.getInstance(Field.class.getName());

  protected String _name="";
  
  public void init(Node node) throws ConfigException
  {
    NamedNodeMap nnl=node.getAttributes();
    Node attr=nnl.getNamedItem("name");
    if (null==attr)
    {
      throw new ConfigException("missing attribute \"name\" while processing FIELD");
    }
    else
    {
      _name=attr.getNodeValue();
    }
  }
  
  public String getValue(Properties data, Properties serverData)
  {
    CAT.info("getValue for "+_name);
    String s=data.getProperty(_name);
    if (null==s)
    {
      s=serverData.getProperty(_name,"");
    }
    CAT.info("replacing field: "+_name+"="+s);
    return s;
  }
}
