/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.kicker.autokicker.eval;

import java.util.Vector;

import org.w3c.dom.*;
import org.log4j.Category;

public class List
{
    static Category CAT = Category.getInstance(List.class.getName());

  protected Field[] _fields=null;
  protected EvalPattern[] _pattern=null;
  
  public void init(Node node, boolean ignoreCase) throws ConfigException
  {
    Vector fv=new Vector();
    Vector pv=new Vector();
    
    NodeList nl=node.getChildNodes();
    for (int i=0;i<nl.getLength();i++)
    {
      Node n=nl.item(i);
      if (n.getNodeType()==n.ELEMENT_NODE)
      {
        String s=n.getNodeName();
        if (s.equals("field"))
        {
          Field f=new Field();
          f.init(n);
          fv.addElement(f);
        }
        else if (s.equals("value"))
        {
          EvalPattern ep=new EvalPattern();
          ep.init(n,ignoreCase);
          pv.addElement(ep);
        }
        else
        {
          throw new ConfigException("unexpected element while processing LIST: "+s);
        }
      }
    }
    if (0!=fv.size())
    {
      _fields=new Field[fv.size()];
      for (int i=0;i<_fields.length;i++)
      {
        _fields[i]=(Field)fv.elementAt(i);
      }
    }
    if (0!=pv.size())
    {
      _pattern=new EvalPattern[pv.size()];
      for (int i=0;i<_pattern.length;i++)
      {
        _pattern[i]=(EvalPattern)pv.elementAt(i);
      }
    }
  }
  
  public Field[] getFields()
  {
    return _fields;
  }
  
  public EvalPattern[] getPatterns()
  {
    return _pattern;
  }
}
