/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.kicker.autokicker.eval;

import org.w3c.dom.*;
import org.log4j.Category;

/**
    create a predicate from a XML node
*/
public class PredicateFactory
{
    static Category CAT = Category.getInstance(PredicateFactory.class.getName());

  public static Predicate createPredicate(String name, Node node) throws ConfigException
  {
    Predicate p=null;
    if (name.equals("and"))
    {
      p=new AndPredicate();
    }
    else if (name.equals("or"))
    {
      p=new OrPredicate();
    }
    else if (name.equals("xor"))
    {
      p=new XorPredicate();
    }
    else if (name.equals("not"))
    {
      p=new NotPredicate();
    }
    else if (name.equals("equals"))
    {
      p=new EqualsPredicate();
    }
    else if (name.equals("contains"))
    {
      p=new ContainsPredicate();
    }
    else if (name.equals("lt"))
    {
      p=new LtPredicate();
    }
    else if (name.equals("gt"))
    {
      p=new GtPredicate();
    }
    else if (name.equals("ip_range"))
    {
      p=new IpRangePredicate();
    }
    if (null!=p)
    {
      p.init(node);
    }
    return p;
  }
}
