/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.output;

import java.io.*;

import org.w3c.dom.Node;
import org.log4j.Category;

import de.hendriklipka.gcp.event.*;
import de.hendriklipka.gcp.exception.*;
import de.hendriklipka.databus.*;

/**
    writes all input events to an output file 
*/
public class InputEventWriter extends OutputFileWriterBase implements DataBusComponent, DataBusConsumer
{
    static Category CAT = Category.getInstance(InputEventWriter.class.getName());

    protected DataBus _bus=null;
    
    String LineFeed="\r\n";
      
    public InputEventWriter()
    {
    }

    public void init(DataBus bus, Node configNode) throws Exception
    {
        _bus=bus;
        _bus.addConsumer(this,InputEvent.NAME);

        super.configure(configNode);
        createWriter();
    }

    public synchronized void dataAvailable(de.hendriklipka.databus.DataBusEvent o)
    {
        try
        {
            InputEvent ie=(InputEvent)(o._data);
            String s=ie._line;
            while (s.endsWith("\n")||s.endsWith("\r"))
                s=s.substring(0,s.length()-1);
            while (s.startsWith("\n")||s.startsWith("\r"))
                s=s.substring(1);
            writeLine(s);
        }
        catch (Throwable ex)
        {
            CAT.error(ex);
        }
    }

    public void start() throws Exception
    {
    }
        
    public void shutdown()
    {
    }
        
    public void deInitialize()
    {
    }
        
    public void reconfig(Node configNode) throws Exception
    {
        super.configure(configNode);
        createWriter();
    }
        
    public void preStartup() throws Exception
    {
    }
    
    public void postStartup() throws Exception
    {
    }
}
