/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.module.output;

import java.util.*;

import org.w3c.dom.Node;
import org.log4j.Category;

import de.hendriklipka.databus.*;
import de.hendriklipka.gcp.exception.*;

public class StdLogOutput implements DataBusComponent,DataBusConsumer
{
    static Category CAT = Category.getInstance(StdLogOutput.class.getName());

    protected DataBus _bus=null;
    
  static final int DEATH=1;
  static final int SUICIDE=2;
  static final int SCORING=3;
  static final int IGNORE=4;
  static final int PLAYERIN=5;
  static final int PLAYEROUT=6;
  static final int ENTERTEAM=7;
  static final int LEAVETEAM=8;
  static final int CHANGETEAM=9;
  static final int RENAME=10;
  static final int ENTERMAP=11;
  static final int LEAVEMAP=12;
  static final int MESSAGE=13;

  protected class MessageEntry
  {
    int Type=0;
    int ScoreType=0;
    int WeaponType=0;
    int FragCount=0;
    int TeamFrag=0;
    int OtherFrag=0;
    String s="";

    MessageEntry(String Entry, int type)
    {
      s=Entry;
      Type=type;
    }
  }  
  protected Hashtable MsgList=new Hashtable();
  
  public void init(DataBus bus, Node configNode)
  {
    _bus=bus;
    /*
    if (null==pfb)
      throw new InitializeException();
    IniFile ifi=null;
    try
    {
      ifi=new IniFile(IniFileName,true);
      System.out.println(IniFileName);
    }
    catch (Exception ex) { throw new InitializeException("error while accessing inifile: "+ex);}
    int num=0;
    System.out.println("offset= "+num);
    num+=addSektion("PlayerIn",num,pfb,ifi,PLAYERIN);
    System.out.println("offset= "+num);
    num+=addSektion("PlayerOut",num,pfb,ifi,PLAYEROUT);
    System.out.println("offset= "+num);
    num+=addSektion("Renaming",num,pfb,ifi,RENAME);
    System.out.println("offset= "+num);
    num+=addSektion("Death1",num,pfb,ifi,DEATH);
    System.out.println("offset= "+num);
    num+=addSektion("Suicide",num,pfb,ifi,SUICIDE);
    System.out.println("offset= "+num);
    num+=addSektion("Scores",num,pfb,ifi,SCORING);
    System.out.println("offset= "+num);
    num+=addSektion("Ignore",num,pfb,ifi,IGNORE);
    System.out.println("offset= "+num);
    num+=addSektion("Message",num,pfb,ifi,MESSAGE);
    System.out.println("offset= "+num);
    num+=addSektion("EnterMap",num,pfb,ifi,ENTERMAP);
    System.out.println("offset= "+num);
    num+=addSektion("LeaveMap",num,pfb,ifi,LEAVEMAP);
    System.out.println("added "+num+" entries");
//    addSektion("PerMap",9000,pfb,ifi);
    boolean fini=false;
    int i=1;
    String s;
    while (!fini)
    {
      try
      {
        s=ifi.getEntry("AllMaps",Integer.toString(i++));
//        System.out.println(s);
        s=doEntry(s);  
        if (0==s.length())
        {
          fini=true;
          break;
        }
        pfb.AddMap(s);
      }
      catch (IniFileExceptionBase ex)
      {
//        System.out.println(ex);
        fini=true;
      }
    }
    System.out.println(i-1+" maps");
    */
  }
  
  public void doOutput()
  {
    /*
    if (null==pfb)
      System.out.println("no processing filter");
    if (!pfb.eventAvailable())
    {
      try
      {
        synchronized (this)
        {
          wait(50);
        }
      }
      catch (InterruptedException ex) {}
      return;
    }
    GameEvent ge=pfb.getNextEvent();
    if (null==ge)
    {
//      System.out.println("error: no game event"); 
    }
    else
    if (null==ge.Line)
    {
//      System.out.println("error: no game event string"); 
    }
    if (ge.MessageType==GameEvent.UNKNOWN)
    {
//      System.out.print(ge.EventDate+" : ");
      System.err.println(ge.MessageType+": <"+ge.Line+">");
    }
    else
    {
      MessageEntry me=(MessageEntry)MsgList.get(new Integer((int)ge.MessageType));
//      System.out.print(me.s);
      if (PLAYERIN==me.Type)
      {
        System.out.println("adding player <"+ge.Player1+">");
        pfb.addPlayerToList(ge.Player1);
      }
      else
      if (PLAYEROUT==me.Type)
      {
        System.out.println("removing player <"+ge.Player1+">");
        pfb.removePlayerFromList(ge.Player1);
      }
      else
      if (RENAME==me.Type)
      {
        System.out.println("renaming:");
        System.out.println("removing player <"+ge.Player2+">");
        pfb.removePlayerFromList(ge.Player2);
        System.out.println("adding player <"+ge.Player1+">");
        pfb.addPlayerToList(ge.Player1);
      }
      else
      if (SUICIDE==me.Type)
      {
        System.out.println("Suicide: "+ge.Player1+" : "+ge.Line);
      }
      else
      if (SCORING==me.Type)
      {
        System.out.println("Scoring: "+ge.Player1+" : "+ge.Line);
      }
      else
      if (DEATH==me.Type)
      {
        System.out.println("Frag for: "+ge.Player1+" against : "+ge.Player2+" : "+ge.Line);
      }
      else
      if (IGNORE==me.Type)
      {
        System.out.println("ignoring: "+ge.Line);
      }
      else
      if (MESSAGE==me.Type)
      {
        System.out.println(ge.Player1+" is talking: "+ge.Line);
      }
      else
      if (ENTERMAP==me.Type)
      {
        System.out.println("Entering map: "+ge.MapName);
        pfb.removeAllPlayers();
      }
      else
      if (LEAVEMAP==me.Type)
      {
        System.out.println("Leaving map: "+ge.MapName);
      }
      else
      {
//        System.out.print(ge.EventDate+" : ");
//        System.out.print(me.Type+": ");
//        System.out.println(ge.Line); 
      }
    }
    */
  }
  
  public boolean isSomethingToDo()
  {
    /*
    if (null==pfb)
    {
      return false;
    }
    if (false==pfb.moreEventsAvailable())
    {
      return false;
    }
    */
    return true;
  }

  String doEntry(String s)
  {
    s=s.trim();
    if (0==s.length())
    {
      return "";
    }
    if ('"'==s.charAt(0))
      s=s.substring(1);
    if ('"'==s.charAt(s.length()-1))
      s=s.substring(0,s.length()-1);
     return s;
  }
  
/*
  int addSektion(String Sektion, int offset, ProcessFilterBase lfb, IniFile ifi, int type)
  {
    boolean fini=false;
    int i=1;
    while (!fini)
    {
      try
      {
        String line=ifi.getEntry(Sektion,Integer.toString(i));
        if (0==line.length())
        {
          fini=true;
          break;
        }
        MessageEntry me=new MessageEntry(line,type);
        MsgList.add(new Integer(i+offset),me);
        line=doEntry(line);
        if (0==line.length())
        {
          fini=true;
          break;
        }
        lfb.addMessage(line,i+offset);
        i++;
      }
      catch (IniFileExceptionBase ex)
      {
//        System.out.println(ex);
        fini=true;
      }
    }
    System.out.println(i-1+" entries added to "+Sektion);
    return i-1;
  }
  */
  public synchronized void dataAvailable(de.hendriklipka.databus.DataBusEvent o)
  {
  }
  
    public void start()
    {
    }
        
    public void shutdown()
    {
    }
        
    public void deInitialize()
    {
    }
        
    public void reconfig(Node configNode)
    {
    }
        
    public void preStartup() throws Exception
    {
    }
    
    public void postStartup() throws Exception
    {
    }
}
