/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.util;

import org.log4j.Category;

import org.w3c.dom.Node;

import de.hendriklipka.gcp.event.InputEvent;

public class Q3AMessageTransformer implements MessageTransformer
{
    protected static Category CAT = Category.getInstance(Q3AMessageTransformer.class.getName());

    public InputEvent transform(InputEvent ie)
    {
        String line=ie._originalLine;
        ie._line=line;

        int l=line.length();
        StringBuffer r=new StringBuffer();
        for (int i=0;i<l;i++)
        {
            char c=line.charAt(i);
            if ((i<l-1)&&('^'==c)&&Character.isDigit(line.charAt(i+1)))
            {
                // color codes are skipped...
                i+=1;
            }
            else
            {
                r.append(c);
            }
        }

        ie._line=r.toString();
        return ie;
    }

    public void init(Node configNode) throws Exception
    {
    }
}
