/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
gcp@hendriklipka.de
*/

package de.hendriklipka.gcp.util;

import java.util.Date;
import java.text.DateFormat;
import java.text.ParseException;

import org.log4j.Category;

import org.w3c.dom.Node;

import de.hendriklipka.gcp.event.InputEvent;

public class QControlMessageTransformer implements MessageTransformer
{
    protected static Category CAT = Category.getInstance(QControlMessageTransformer.class.getName());
    protected DateFormat df=DateFormat.getInstance();

    public InputEvent transform(InputEvent ie)
    {
        String line=ie._originalLine;
        ie._line=line;

        String s1=null;
        try
        {
            s1=line.substring(30);
        }
        catch (StringIndexOutOfBoundsException ex)
        {
            return ie;
        }
        // filter lines not from the qcontrol console
        if (0!=line.substring(25,29).compareTo("con:"))
        {
            return ie;
        }
        // convert hex number ([xx]) into normal chars
        StringBuffer r=new StringBuffer();
        int l=s1.length();
        for (int i=0;i<l;i++)
        {
            char c=s1.charAt(i);
            if ((i<l-3)&&('['==c)&&(']'==s1.charAt(i+3)))
            {
                try
                {
                    int j=Integer.parseInt(s1.substring(i+1,i+3),16);
                    r.append((char)j);
                }
                catch (NumberFormatException ex) {}
                i+=3;
            }
            else
            {
                r.append(c);
            }
        }

        try
        {
          ie._eventDate=df.parse(line.substring(0,24));
        }
        catch (java.text.ParseException ex)
        {
          ie._eventDate=new Date();
        }

        ie._line=r.toString();
        return ie;
    }

    /**
     * @todo add character translation table
     */
    public void init(Node configNode) throws Exception
    {
        // do nothing - there is no configuration
    }
}
